﻿<?xml version="1.0" encoding="utf-8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
xmlns="http://schemas.openxmlformats.org/spreadsheetml/2006/main" xmlns:r="http://schemas.openxmlformats.org/officeDocument/2006/relationships" xmlns:xdr="http://schemas.openxmlformats.org/drawingml/2006/spreadsheetDrawing" xmlns:x14="http://schemas.microsoft.com/office/spreadsheetml/2009/9/main" xmlns:mc="http://schemas.openxmlformats.org/markup-compatibility/2006" xmlns:x14ac="http://schemas.microsoft.com/office/spreadsheetml/2009/9/ac">
  <xsl:output method="xml" indent="yes"/>
  <xsl:template match="node()[name()='row']">
    <xsl:if test="not(@r)">
      <xsl:choose>
        <xsl:when test="count(*)=0"/>
        <xsl:otherwise>
          <xsl:copy>
            <xsl:copy-of select="@*"/>
            <xsl:attribute name="r">
              <xsl:value-of select="count(preceding-sibling::node()[name()='row']) +1"/>
            </xsl:attribute>
            <xsl:apply-templates select="*">
              <xsl:with-param name="row" select="count(preceding-sibling::node()[name()='row']) +1"/>
            </xsl:apply-templates>
          </xsl:copy>
        </xsl:otherwise>
      </xsl:choose>
    </xsl:if>
    <xsl:if test="@r">
      <xsl:copy-of select="."/>
    </xsl:if>
  </xsl:template>
  <xsl:template match="node()[name()='c']">
    <xsl:param name="row"/>
    <xsl:if test="string-length(@r)=1">
      <xsl:copy>
        <xsl:copy-of select="@*[not(.='merge')]"/>
        <xsl:attribute name="r">
          <xsl:value-of select="concat(@r,$row)"/>
        </xsl:attribute>
        <xsl:apply-templates/>
      </xsl:copy>
    </xsl:if>
    <xsl:if test="string-length(@r)!=1">
      <xsl:copy-of select="."/>
    </xsl:if>
  </xsl:template>
  <xsl:template match="node()[name()='mergeCells']">
    <xsl:copy>
    <xsl:attribute name="count">
      <xsl:value-of select="count(..//@*[.='merge'])"/>
    </xsl:attribute>
    <!--<mergeCell ref="D22:E22"/>-->
    <xsl:for-each select="..//@*[.='merge']/..">
      <xsl:variable name="count" select="count(../preceding-sibling::node()[name()='row']) +1"/>
      <mergeCell>
        <xsl:attribute name="ref">
          <xsl:value-of select="concat(preceding-sibling::*[1]/@*[name()='r'],$count,':',@r,$count)"/>
        </xsl:attribute>
      </mergeCell>
    </xsl:for-each>
    </xsl:copy>
  </xsl:template>
  <xsl:template match="@* | node()">
    <xsl:copy>
      <xsl:apply-templates select="@* | node()"/>
    </xsl:copy>
  </xsl:template>
</xsl:stylesheet>
